package com.zhongzheng.modules.pay.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.pay.domain.PayAisle;
import com.zhongzheng.modules.pay.domain.PayCost;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.pay.bo.PayNatureAddBo;
import com.zhongzheng.modules.pay.bo.PayNatureQueryBo;
import com.zhongzheng.modules.pay.bo.PayNatureEditBo;
import com.zhongzheng.modules.pay.domain.PayNature;
import com.zhongzheng.modules.pay.mapper.PayNatureMapper;
import com.zhongzheng.modules.pay.vo.PayNatureVo;
import com.zhongzheng.modules.pay.service.IPayNatureService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 收费性质Service业务层处理
 *
 * @author ruoyi
 * @date 2021-10-12
 */
@Service
public class PayNatureServiceImpl extends ServiceImpl<PayNatureMapper, PayNature> implements IPayNatureService {

    @Override
    public PayNatureVo queryById(Long natureId){
        PayNature db = this.baseMapper.selectById(natureId);
        return BeanUtil.toBean(db, PayNatureVo.class);
    }

    @Override
    public List<PayNatureVo> queryList(PayNatureQueryBo bo) {
        LambdaQueryWrapper<PayNature> lqw = Wrappers.lambdaQuery();
        lqw.like(StrUtil.isNotBlank(bo.getNatureName()), PayNature::getNatureName, bo.getNatureName());
        lqw.in(bo.getStatus() != null, PayNature::getStatus, bo.getStatus());
        lqw.orderByDesc(PayNature::getUpdateTime);
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<PayNatureVo> entity2Vo(Collection<PayNature> collection) {
        List<PayNatureVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, PayNatureVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<PayNature> page = (Page<PayNature>)collection;
            Page<PayNatureVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(PayNatureAddBo bo) {
        PayNature add = BeanUtil.toBean(bo, PayNature.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(PayNatureEditBo bo) {
        PayNature update = BeanUtil.toBean(bo, PayNature.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(PayNature entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
